'Written by DW of Dark Systems BBS
'January of 2025
'Version 1.0

'Written in QuickBasic 4.5 for MSDOS.

'A simple line drawing tool that lets you
'quickly and easily plot line coordinates
'and draw shapes for use in your QuickBasic programs.

'Free to use for any purpose & free to distribute.

'Please feel free to modify this source code to
'learn, improve and customize for your own requirments!
'I've tried to comment everything to make it easy.

'Feedback always welcome.
'eMail: aaron@jaggedpath.com
'          or
'FidoNET: dw@1:229/428

'Don't foret to visit Dark Systems BBS
'An early 90s style BBS still rocking
'RemoteAccess like it's 1994!
' :)

'On the web: www.dsbbs.ca
'          or
'Telnet: bbs.dasbbs.ca:23


'Create share & enjoy!



'------------- PROGRAM STARTS -------------

SCREEN 13 '320x200 / 256 colours / 40x25 characters

'Draw the bottom X-axis
FOR x = 0 TO 319 STEP 5
    PSET (x, 199), 14 'Yellow (14) for the X-axis dots
NEXT x

'Draw the left side Y-axis
FOR y = 0 TO 199 STEP 5
    PSET (0, y), 11 'Teal colour (11) for the Y-axis dots
NEXT y

'Draw the dark grey grid pattern
'Grid resolution is 5 pixels, so STEP 5
COLOR 8
FOR y = 5 TO 195 STEP 5 'Start the grey grid dots at Y+5 to avoid overwriting the Y-axis teal dots
    FOR x = 5 TO 319 STEP 5 'Start the grey grid dots at X+5 to avoid overwriting the X-axis yellow dots
	PSET (x, y) 'smack down a dark grey grid dot every 5 pixel steps
    NEXT x
NEXT y

'Set the initial spacebar tracker to 0
'When spacebar is pressed the 1st time, set bar to 1
'When spacebar is pressed the 2nd time, set bar to 0
bar = 0

'Initialize cursor position and set it's starting coordinates to screen centre
cursorX = 160 'X
cursorY = 100 'Y

'Draw initial red cursor pixel at starting position
PSET (cursorX, cursorY), 12

'Store the initial red pixel position
lastX = cursorX
lastY = cursorY

'Print the initial X,Y cursor coordinates at the top of the screen
LOCATE 1, 1: COLOR 14: PRINT "X: "; cursorX; : COLOR 11: PRINT "  Y: "; cursorY; : PRINT "     "

'Initialize start and end points
startX = -1
startY = -1
endX = -1
endY = -1

'Arrays to store lines (start and end points)
DIM linesStartX(100), linesStartY(100), linesEndX(100), linesEndY(100)
lineCount = 0 ' Counter for the number of lines

'Main loop to move the red cursor pixel around and draw the line
DO
   'Wait for a key press and check which key has been pressed
   key$ = INKEY$
   
   'Exit the program if ESC key is pressed (ASCII 27)
   IF key$ = CHR$(27) THEN EXIT DO
   
   'Check for 'S' or 's' key to save your beautiful line drawing to a file
   IF key$ = CHR$(83) OR key$ = CHR$(115) THEN
       'Ask the user to type a file name
       LOCATE 1, 24: COLOR 7: PRINT ".bas" 'Print the file extension after the filename
       LOCATE 1, 1: COLOR 4: PRINT "SAVE "; : COLOR 14: LOCATE 1, 6: PRINT "File name:        "; : COLOR 15'Print the actual save text line
       
       'We're going to do a little file i/o check here
       'Loop until a valid filename is typed
       fileName$ = "" 'Reset the filename variable
       filePos = 16 'Position cursor after prompt ("File name:        ")
       
       DO
	   LOCATE 1, filePos 'Move cursor to current position
	   key$ = INKEY$
	   
	   'Check if a key is pressed
	   IF key$ <> "" THEN
	       'If backspace is pressed, remove last character
	       IF ASC(key$) = 8 AND LEN(fileName$) > 0 THEN
		   fileName$ = LEFT$(fileName$, LEN(fileName$) - 1)
		   filePos = filePos - 1 'Move the cursor back
		   LOCATE 1, filePos 'Move the cursor back one position
		   PRINT " "; 'Erase the character
		   LOCATE 1, filePos 'Reposition cursor
	       ELSE
		   'If the key is a valid character (non-control) do this to show the typed character
		   'This also checks to make sure the filename is DOS complient, so MAX 8 characters
		   IF (ASC(key$) >= 32 AND ASC(key$) <= 126) AND LEN(fileName$) < 8 THEN
		       fileName$ = fileName$ + key$
		       PRINT key$ 'Display the typed character
		       filePos = filePos + 1 'Move the cursor to the next position
		   END IF
	       END IF
	   END IF
	   
	   'If the filename is 8 characters long, stop accepting input
	   IF LEN(fileName$) >= 8 THEN
	       LOCATE 1, filePos 'Stop moving cursor after 8 characters or DOS will be angry
	   END IF
	   
	   'Exit the filename loop if enter is pressed AND the typed filename is longer than 0 character(s)
       LOOP UNTIL key$ = CHR$(13) AND LEN(fileName$) > 0
       
       'Automatically add .bas as the file extension
       fileName$ = fileName$ + ".bas"
       
       'Open the file to save beautifully artistic lines
       OPEN fileName$ FOR OUTPUT AS #1
       
       'Loop through all lines in the arrays and save them to the file
       FOR i = 1 TO lineCount
	   PRINT #1, "LINE ("; linesStartX(i); ","; linesStartY(i); ") - ("; linesEndX(i); ","; linesEndY(i); "), 13"
       NEXT i
       
       'Close the file
       CLOSE #1
       
       'Print that the file was saved in the top banner bar
       LOCATE 1, 19: COLOR 7: PRINT "          :"; : COLOR 10: PRINT "SAVED"; : COLOR 7: PRINT ":"
   END IF
   
   'Check for a press from the 'C' or 'c' key which will clear the screen and reset the grid
   IF key$ = CHR$(67) OR key$ = CHR$(99) THEN
       'Clear the screen and reset the drawing grid and coordinates
       CLS
       'Re-draw both axes and grid
       FOR x = 0 TO 319 STEP 5
	   PSET (x, 199), 14 'Yellow X-axis dots
       NEXT x

       FOR y = 0 TO 199 STEP 5
	   PSET (0, y), 11 'Teal Y-axis dots
       NEXT y
       
       COLOR 8 'Dark grey for grid lines
       FOR y = 5 TO 195 STEP 5
	   FOR x = 5 TO 319 STEP 5
	       PSET (x, y) 'Wack the grey dots down in 5 pixel steps
	   NEXT x
       NEXT y
       
       'Reset the red cursor to center screen
       cursorX = 160
       cursorY = 100
       PSET (cursorX, cursorY), 12 'Bright red (12) for the cursor
       lastX = cursorX
       lastY = cursorY
       
       'Reset the start/end points
       startX = -1
       startY = -1
       endX = -1
       endY = -1
       
       'Clear any stored lines
       lineCount = 0
       
       'Reset fancy top coordinates x/y display
       LOCATE 1, 1: COLOR 14: PRINT "X: "; cursorX; : COLOR 11: PRINT "  Y: "; cursorY; : PRINT "     "
   END IF

   'Update the x and y coordinate readout at the top of the screen
   LOCATE 1, 1: COLOR 14: PRINT "X: "; cursorX; : COLOR 11: PRINT "  Y: "; cursorY; : PRINT "     "

   'Move the red pixel cursor around the grey grid based on arrow key input
   IF key$ = CHR$(0) + CHR$(75) AND cursorX > 5 THEN cursorX = cursorX - 5 ' Left arrow
   IF key$ = CHR$(0) + CHR$(77) AND cursorX < 315 THEN cursorX = cursorX + 5 ' Right arrow
   IF key$ = CHR$(0) + CHR$(72) AND cursorY > 5 THEN cursorY = cursorY - 5 ' Up arrow
   IF key$ = CHR$(0) + CHR$(80) AND cursorY < 195 THEN cursorY = cursorY + 5 ' Down arrow
   
   'Check if the red pixel position has changed
   IF cursorX <> lastX OR cursorY <> lastY THEN

       'Set the red pixels previous grid position to grey (8)
       PSET (lastX, lastY), 8
       
       'Draw the red pixel (12) OR blue pixel (9) depending on the bar flag value, at the current grid position
       IF bar = 1 THEN pixelcolour = 9
       IF bar = 0 THEN pixelcolour = 12
       PSET (cursorX, cursorY), pixelcolour 'pixelcolour is either red or blue (12 or 9) depending on bar flag
	   'Set the grid pixel location to blue (9) at the start X/Y coordinates of the line so you have a start reference
       PSET (startX, startY), 9
       
       'Update the last position to reflect the new red or blue pixel location
       lastX = cursorX
       lastY = cursorY
       
       'Clear the previous X/Y coordinates screen readout
       LOCATE 1, 13: PRINT "                            ";
       
       'Print the current red or blue pixel X/Y coordinates at the top of the screen
       LOCATE 1, 1: COLOR 14: PRINT "X: "; cursorX; : COLOR 11: PRINT "  Y: "; cursorY; : PRINT "     "
    END IF
    
    'Check if the spacebar (chr$(32)) is pressed (to mark start or end of line)
    IF key$ = CHR$(32) THEN
	IF startX = -1 AND startY = -1 THEN
	    'First spacebar press - mark the START point with bright blue pixel (9)
	    'Change the bar flag from 0 to 1
	    bar = 1
	    startX = cursorX
	    startY = cursorY
	    PSET (startX, startY), 9
	ELSE
	    'Second spacebar press - mark the END point
	    bar = 0
	    endX = cursorX
	    endY = cursorY
	    PSET (endX, endY), 9
	    
	    'Draw the line between the start and end points
	    LINE (startX, startY)-(endX, endY), 10 ' Draw line in bright green (10)
	    
	    'Store the line coordinates in arrays
	    lineCount = lineCount + 1
	    linesStartX(lineCount) = startX
	    linesStartY(lineCount) = startY
	    linesEndX(lineCount) = endX
	    linesEndY(lineCount) = endY
	    
	    'Reset cursor to red (12) for normal movement around the grid
	    PSET (cursorX, cursorY), 12
	    
	    'Reset start and end points
	    startX = -1
	    startY = -1
	    endX = -1
	    endY = -1
	    
	    'Clear the coordinates display at the top bar
	    LOCATE 1, 13: PRINT "                            "; ' Clear coordinates
	END IF
    END IF
    
LOOP 'Loop continues until the ESC key is pressed
END

